HDU 5113 Black And White(DFS)

来源:互联网 发布:js如何控制光标大小 编辑:程序博客网 时间:2024/06/06 03:45

Black And White

Time Limit: 2000/2000 MS (Java/Others)    Memory Limit: 512000/512000 K (Java/Others)
Total Submission(s): 4934    Accepted Submission(s): 1334
Special Judge


Problem Description
In mathematics, the four color theorem, or the four color map theorem, states that, given any separation of a plane into contiguous regions, producing a figure called a map, no more than four colors are required to color the regions of the map so that no two adjacent regions have the same color.
— Wikipedia, the free encyclopedia

In this problem, you have to solve the 4-color problem. Hey, I’m just joking.

You are asked to solve a similar problem:

Color an N × M chessboard with K colors numbered from 1 to K such that no two adjacent cells have the same color (two cells are adjacent if they share an edge). The i-th color should be used in exactly ci cells.

Matt hopes you can tell him a possible coloring.
 

Input
The first line contains only one integer T (1 ≤ T ≤ 5000), which indicates the number of test cases.

For each test case, the first line contains three integers: N, M, K (0 < N, M ≤ 5, 0 < K ≤ N × M ).

The second line contains K integers ci (ci > 0), denoting the number of cells where the i-th color should be used.

It’s guaranteed that c1 + c2 + · · · + cK = N × M .
 

Output
For each test case, the first line contains “Case #x:”, where x is the case number (starting from 1). 

In the second line, output “NO” if there is no coloring satisfying the requirements. Otherwise, output “YES” in one line. Each of the following N lines contains M numbers seperated by single whitespace, denoting the color of the cells.

If there are multiple solutions, output any of them.
 

Sample Input
41 5 24 13 3 41 2 2 42 3 32 2 23 2 32 2 2
 

Sample Output
Case #1:NOCase #2:YES4 3 42 1 24 3 4Case #3:YES1 2 32 3 1Case #4:YES1 22 33 1
 

Source
2014ACM/ICPC亚洲区北京站-重现赛(感谢北师和上交)


【思路】

可以看到数据非常小,所以我们可以直接暴力做这道题目,从上往下、从左往右填每个格子即可。可以剪枝的情况:先对剩下的格子像国际象棋棋盘那样黑白分块,任何一种颜色剩下的颜料只可按照黑块或白块那么填,所以不会多于空白块的一半,故可剪去未来必定填错的情况。


【代码】

#include <cstdio>#include <cstring>#include <algorithm>using namespace std;const int MAXN = 30;int t, n, m, k;int c[MAXN];int mp[MAXN][MAXN];bool flag;bool ok(int x, int y){    return (1 <= x && x <= n && 1 <= y && y <= m);}void dfs(int x, int y){    if (x > n) {flag = true; return;}    int remain = m * n - ((x - 1) * m + y - 1);    for (int i = 1; i <= k; i++)        if ((remain + 1) / 2 < c[i]) return;    for (int i = 1; i <= k && !flag; i++) {        if (c[i] == 0) continue;        if (ok(x - 1, y) && mp[x - 1][y] == i || ok(x, y - 1) && mp[x][y - 1] == i) continue;        c[i]--;        mp[x][y] = i;        if (y + 1 <= m)            dfs(x, y + 1);        else            dfs(x + 1, 1);        c[i]++;    }}int main(){    scanf("%d", &t);    for (int kase = 1; kase <= t; kase++) {        scanf("%d %d %d", &n, &m, &k);        for (int i = 1; i <= k; i++) scanf("%d", &c[i]);        flag = false;        dfs(1, 1);        if (!flag)            printf("Case #%d:\nNO\n", kase);        else {            printf("Case #%d:\nYES\n", kase);            for (int i = 1; i <= n; i++) {                for (int j = 1; j <= m; j++) {                    printf("%d", mp[i][j]);                    if (j != m) printf(" ");                }                printf("\n");            }        }    }    return 0;}



原创粉丝点击